--- old/usr/src/tools/smatch/src/smatch_fresh_alloc.c	Tue May 19 02:50:33 2020
+++ new/usr/src/tools/smatch/src/smatch_fresh_alloc.c	Tue May 19 02:50:33 2020
@@ -23,6 +23,7 @@
  */
 
 #include "smatch.h"
+#include "smatch_extra.h"
 #include "smatch_slist.h"
 
 static int my_id;
@@ -65,6 +66,16 @@
 	{},
 };
 
+static void pre_merge_hook(struct sm_state *cur, struct sm_state *other)
+{
+	struct smatch_state *state;
+	sval_t sval;
+
+	state = get_state(SMATCH_EXTRA, cur->name, cur->sym);
+	if (estate_get_single_value(state, &sval) && sval.value == 0)
+		set_state(my_id, cur->name, cur->sym, &undefined);
+}
+
 static int fresh_callback(void *fresh, int argc, char **argv, char **azColName)
 {
 	*(int *)fresh = 1;
@@ -150,12 +161,23 @@
 	} END_FOR_EACH_PTR(arg);
 }
 
+static struct expression *handled;
 static void set_fresh(struct expression *expr)
 {
+	struct range_list *rl;
+
 	expr = strip_expr(expr);
 	if (expr->type != EXPR_SYMBOL)
 		return;
+	if (expr == handled)
+		return;
+
+	get_absolute_rl(expr, &rl);
+	rl = rl_intersection(rl, valid_ptr_rl);
+	if (!rl)
+		return;
 	set_state_expr(my_id, expr, &fresh);
+	handled = expr;
 }
 
 static void returns_fresh_alloc(struct expression *expr, int param, char *key, char *value)
@@ -192,4 +214,6 @@
 	select_return_states_hook(FRESH_ALLOC, &returns_fresh_alloc);
 	add_hook(&match_assign, ASSIGNMENT_HOOK);
 	add_hook(&match_call, FUNCTION_CALL_HOOK);
+
+	add_pre_merge_hook(my_id, &pre_merge_hook);
 }
